;;; For a positive delay, returns a stream
;;; with "delay" zeros prepended.  For 
;;; negative delays, removes "delay" items
;;; from the input.
(define (stream-delay stream delay)
  (cond ((= delay 0) stream)
        ((> delay 0)
         (cons-stream 
          0 
          (stream-delay stream 
                        (dec delay))))
        (else 
         (stream-delay (stream-cdr stream)
                       (inc delay)))))
